VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDPic"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const FLOODFILLBORDER = 0
Private Const FLOODFILLSURFACE = 1
Private Declare Function ExtFloodFill Lib "gdi32" ( _
  ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, _
  ByVal crColor As Long, ByVal wFillType As Long) As Long

Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long

Private fPic1Move As Boolean
Private lBorder2 As Long          ' ganze Rahmenbreite
Private lBorder1 As Long          ' halbe Rahmenbreite
Private lBorder3 As Long          ' abs(halbe Rahmenbreite)
Private lHotspotX As Long         ' Hotspot im Bitmap
Private lHotspotY As Long

Private BAlt As Integer           ' alte Maustaste
Private XAlt As Single            ' alte Mausposition
Private YAlt As Single

Private WithEvents mPicE As PictureBox ' Pinsel
Attribute mPicE.VB_VarHelpID = -1
Private mPic As PictureBox

Private WithEvents dPic As PictureBox     ' Oberflche
Attribute dPic.VB_VarHelpID = -1
Private WithEvents dFrm As Form           ' Form als Oberflche
Attribute dFrm.VB_VarHelpID = -1
Private WithEvents dBtn As CommandButton  ' PushButton als Oberflche
Attribute dBtn.VB_VarHelpID = -1
Private WithEvents dOpt As OptionButton   ' Radiobutton als Oberflche
Attribute dOpt.VB_VarHelpID = -1
Private WithEvents dFra As Frame          ' Groupbox als Oberflche
Attribute dFra.VB_VarHelpID = -1
Private WithEvents dChk As CheckBox
Attribute dChk.VB_VarHelpID = -1
Private WithEvents dLbl As Label
Attribute dLbl.VB_VarHelpID = -1

Public Enum DrawMode_DPic
  None = 0
  Dots = 1
  Freehand = 2
  Floodfill = 3
End Enum

Public Enum MouseCur_DPic
  mcNone = -1
  mcDefault = vbDefault '0 (Default) Shape determined by the object.
  mcArrow = vbArrow '1 Arrow.
  mcCrosshair = vbCrosshair '2 Cross (crosshair pointer).
  mcIBeam = vbIbeam '3 I beam.
  mcIconPointer = vbIconPointer '4 Icon (small square within a square).
'  mcSizePointer = vbSizePointer '5 Size (four-pointed arrow pointing north, south, east, and west).
'  mcSizeNESW = vbSizeNESW '6 Size NE SW (double arrow pointing northeast and southwest).
'  mcSizeNS = vbSizeNS '7 Size N S (double arrow pointing north and south).
'  mcSizeNWSE = vbSizeNWSE '8 Size NW SE (double arrow pointing northwest and southeast).
'  mcSizeWE = vbSizeWE '9 Size W E (double arrow pointing west and east).
'  mcUpArrow = vbUpArrow '10 Up Arrow.
'  mcHourglass = vbHourglass '11 Hourglass (wait).
'  mcNoDrop = vbNoDrop '12 No Drop.
'  mcArrowHourglass = vbArrowHourglass '13 Arrow and hourglass.
'  mcArrowQuestion = vbArrowQuestion '14 Arrow and question mark.
'  mcSizeAll = vbSizeAll '15 Size all.
'  mcCustom = vbCustom '99 Custom icon specified by the MouseIcon property
End Enum

'Private aColor(3) As Long         ' Farbe zur Maustaste
Public DrawMode As DrawMode_DPic
Public lIgnoreBackCol As Long ' damit Floodfill-Randfarbe erhalten bleibt
Public ctrlDraw As Object

Private Sub dBtn_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  mPic.Top = Y - lHotspotY + dBtn.Top + lBorder1
  mPic.Left = X - lHotspotX + dBtn.Left + lBorder2
End Sub

Private Sub dChk_Click()
  Dim iIdx As Long
  Dim p As Form
  Dim sz As String
  Dim fArb As Boolean

  If dChk.Enabled Then
    Set p = dChk.Parent
    sz = Left(dChk.Tag, 5)
    If sz = "DStyl" Then
      nDStyl = Val(Mid(dChk.Tag, 6))
      p.PBDStyl.Value = 1
      fArb = True
    ElseIf sz = "EStyl" Then
      nEStyl = Val(Mid(dChk.Tag, 6))
      p.PBEStyl.Value = 1
      fArb = True
    End If
    If fArb Then
      For iIdx = 0 To p.Count - 1
        If Left(p.Controls(iIdx).Tag, 5) = sz Then
          If dChk.Tag <> p.Controls(iIdx).Tag And _
             p.Controls(iIdx).Enabled = False Then
            p.Controls(iIdx).Value = 0
            p.Controls(iIdx).Enabled = True
          End If
        End If
      Next iIdx
      dChk.Enabled = False
      p.Pic1.SetFocus
    End If
  End If
End Sub

Private Sub dChk_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  mPic.Top = Y - lHotspotY + dChk.Top + lBorder1
  mPic.Left = X - lHotspotX + dChk.Left + lBorder2
End Sub

Private Sub dFra_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  mPic.Top = Y - lHotspotY + dFra.Top + lBorder1
  mPic.Left = X - lHotspotX + dFra.Left + lBorder2
End Sub

Private Sub dFrm_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  mPic.Top = Y - lHotspotY + dFrm.Top + lBorder1 ' x: 120  y: 3840  (twips)
  mPic.Left = X - lHotspotX + dFrm.Left + lBorder2 ' x: 8 y: 256 (pixel)
End Sub

Private Sub dLbl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  mPic.Top = Y - lHotspotY + dLbl.Top + lBorder1
  mPic.Left = X - lHotspotX + dLbl.Left + lBorder2
End Sub

Private Sub dOpt_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  mPic.Top = Y - lHotspotY + dOpt.Top + lBorder1
  mPic.Left = X - lHotspotX + dOpt.Left + lBorder2
End Sub

Private Sub dPic_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  mPic.Top = Y - lHotspotY + dPic.Top + lBorder1 ' x: 120  y: 3840  (twips)
  mPic.Left = X - lHotspotX + dPic.Left + lBorder2 ' x: 8 y: 256 (pixel)
  ' x: 300  y: 3510
  If Button > 0 And DrawMode <> None Then
    If BAlt = Button And DrawMode = Freehand Then
      dPic.Line (XAlt, YAlt)-(X, Y), MapMouseB2Color(Button)
    ElseIf DrawMode = Dots Then
      dPic.PSet (X, Y), MapMouseB2Color(Button)
    End If
    BAlt = Button
    XAlt = X
    YAlt = Y
  Else
    BAlt = 0
  End If
End Sub

Private Sub dPic_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Static lPixX As Long
  Static lPixY As Long
  If Button = 1 Or Button = 2 Then
    If DrawMode = None Then
      If Left(dPic.Tag, 6) = "Farbe:" Then
'        If Button = 1 Then
          MBLColor = CLng(Mid(dPic.Tag, 7))
'        Else
'          MBRColor = CLng(Mid(dPic.Tag, 7))
'        End If
          MBRColor = MBLColor
          MB3Color = MBLColor
          Call PinselFarbeSetzen(MBLColor)
      End If
    ElseIf DrawMode = Floodfill Then
      Dim lOrgColor As Long
      Dim l As Long
      If dPic.ScaleMode = vbTwips Then
        lPixX = X / Screen.TwipsPerPixelX
        lPixY = Y / Screen.TwipsPerPixelY
      Else
        lPixX = X
        lPixY = Y
      End If
      lOrgColor = GetPixel(dPic.hdc, lPixX, lPixY)
      If lIgnoreBackCol <> lOrgColor Then
        dPic.FillStyle = vbFSSolid
        dPic.FillColor = MapMouseB2Color(Button)
        l = ExtFloodFill(dPic.hdc, lPixX, lPixY, _
          lOrgColor, FLOODFILLSURFACE)
        dPic.Refresh
      End If
    ElseIf DrawMode = Dots Or DrawMode = Freehand Then
      dPic.PSet (X, Y), MapMouseB2Color(Button)
      BAlt = Button
      XAlt = X
      YAlt = Y
    End If
  End If
End Sub

Public Function Init( _
  DrawPic As Object, _
  HandPic As PictureBox, _
  HotspotX As Long, _
  HotspotY As Long, _
  fCreaRegion As Boolean, _
  MouseCur As MouseCur_DPic _
  ) As Boolean
  Dim ret As Long
  Dim hRegion As Long
  Dim lOK As Long
  Dim TScaleMode As Long

  lIgnoreBackCol = -1
  Init = True

  lHotspotX = HotspotX
  lHotspotY = HotspotY

  Set mPic = HandPic
  If TypeOf DrawPic Is Form Then
    Set dFrm = DrawPic
    lBorder2 = 3
    lBorder1 = 2
    TScaleMode = DrawPic.ScaleMode
  ElseIf TypeOf DrawPic Is PictureBox Then
    Set dPic = DrawPic
    dPic.AutoRedraw = True
    If dPic.BorderStyle = 0 Then
      lBorder2 = 0
      lBorder1 = -1
    Else
      lBorder2 = 2
      lBorder1 = 1
    End If
    TScaleMode = DrawPic.ScaleMode
  ElseIf TypeOf DrawPic Is CommandButton Then
    lBorder2 = 0
    lBorder1 = -1
    Set dBtn = DrawPic
    TScaleMode = DrawPic.Parent.ScaleMode
  ElseIf TypeOf DrawPic Is CheckBox Then
    Set dChk = DrawPic
    lBorder2 = 0
    lBorder1 = -1
    TScaleMode = DrawPic.Parent.ScaleMode
  ElseIf TypeOf DrawPic Is OptionButton Then
    Set dOpt = DrawPic
    TScaleMode = DrawPic.Parent.ScaleMode
  ElseIf TypeOf DrawPic Is Frame Then
    Set dFra = DrawPic
    If dFra.BorderStyle = 0 Then
      lBorder2 = 0
      lBorder1 = -1
    Else
      lBorder2 = 2
      lBorder1 = 1
    End If
    TScaleMode = DrawPic.Parent.ScaleMode
  ElseIf TypeOf DrawPic Is Label Then
    Set dLbl = DrawPic
    lBorder2 = 0
    lBorder1 = -1
    TScaleMode = DrawPic.Parent.ScaleMode
  End If
  Set ctrlDraw = DrawPic        ' ist public - dient nur zur Info!!
  If fCreaRegion Then
    Set mPicE = mPic
    hRegion = RegionFromImage(mPic, GetPixel(mPic.hdc, 0, 0))
    SetWindowRgn mPic.hwnd, hRegion, True
    lOK = DeleteObject(hRegion)
  End If

  If TScaleMode = vbTwips Then
    lHotspotX = lHotspotX * Screen.TwipsPerPixelX
    lHotspotY = lHotspotY * Screen.TwipsPerPixelY
    lBorder2 = lBorder2 * Screen.TwipsPerPixelX
    lBorder1 = lBorder1 * Screen.TwipsPerPixelX
  End If
  lBorder3 = Abs(lBorder1)

  DrawPic.MousePointer = MouseCur
  mPic.MousePointer = MouseCur

End Function

Private Function MapMouseB2Color(Button As Integer) As Long
  Select Case Button
    Case 1
      MapMouseB2Color = MBLColor
    Case 2
      MapMouseB2Color = MBRColor
    Case 3
      MapMouseB2Color = MB3Color
  End Select
End Function

Private Sub mPicE_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  If fPic1Move Then
  Else
   If 1 = 1 Then
      fPic1Move = True
      mPic.Top = mPic.Top + Y - lHotspotY - lBorder3
      DoEvents
      mPic.Left = mPic.Left + X - lHotspotX
      DoEvents
      fPic1Move = False
    End If
  End If
End Sub

